# ASF

Read and write ASF (Window Media Audio) files.

class mutagen.asf.ASF(filething)

  Bases: `FileType`

  An ASF file, probably containing WMA or WMV.

  Parameters:

    filething (filething)

  info
    Type:

      `ASFInfo`

  tags
    Type:

      `ASFTags`

  load(filething)
    Parameters:

      filething (filething)

    Raises:

      mutagen.MutagenError –

  save(filething=None, padding=None)

    Save tag changes back to the loaded file.

    Parameters:

      - filething (filething)

      - padding (`mutagen.PaddingFunction`)

    Raises:

      mutagen.MutagenError –

  add_tags()

    Adds new tags to the file.

    Raises:

      mutagen.MutagenError – if tags already exist or adding is not possible.

  delete(filething=None)
    Parameters:

      filething (filething)

    Raises:

      mutagen.MutagenError –

  static score(filename, fileobj, header)

    Returns a score for how likely the file can be parsed by this type.

    Parameters:

      - filename (fspath) – a file path

      - fileobj (fileobj) – a file object open in rb mode. Position is undefined

      - header (bytes) – data of undefined length, starts with the start of the file.

    Returns:

      negative if definitely not a matching type, otherwise a score,

        the bigger the more certain that the file can be loaded.

    Return type:

      int

class mutagen.asf.ASFInfo

  Bases: `StreamInfo`

  ASF stream information.

  length

    “Length in seconds

    Type:

      `float`

  sample_rate

    Sample rate in Hz

    Type:

      `int`

  bitrate

    Bitrate in bps

    Type:

      `int`

  channels

    Number of channels

    Type:

      `int`

  codec_type

    Name of the codec type of the first audio stream or an empty string if unknown. Example: `Windows Media Audio 9 Standard`

    Type:

      `mutagen.text`

  codec_name

    Name and maybe version of the codec used. Example: `Windows Media Audio 9.1`

    Type:

      `mutagen.text`

  codec_description

    Further information on the codec used. Example: `64 kbps, 48 kHz, stereo 2-pass CBR`

    Type:

      `mutagen.text`

  pprint()

    Returns: text: a stream information text summary

class mutagen.asf.ASFTags

  Bases: `list`, `DictMixin`, `Tags`

  Dictionary containing ASF attributes.

  keys()

    Return a sequence of all keys in the comment.

  as_dict()

    Return a copy of the comment data in a real dict.

  pprint()

    Returns a string containing all key, value pairs.

    Return type:

      text

class mutagen.asf.ASFBaseAttribute

  Generic attribute.

  language = None

    Language

  stream = None

    Stream

  value = None

    The Python value of this attribute (type depends on the class)

class mutagen.asf.ASFGUIDAttribute(value)

  GUID attribute.

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFWordAttribute(value)

  WORD attribute.

      ASFWordAttribute(42)

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFDWordAttribute(value)

  DWORD attribute.

      ASFDWordAttribute(42)

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFQWordAttribute(value)

  QWORD attribute.

      ASFQWordAttribute(42)

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFBoolAttribute(value)

  Bool attribute.

      ASFBoolAttribute(True)

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFByteArrayAttribute(value)

  Byte array attribute.

      ASFByteArrayAttribute(b'1234')

  Bases:

    `ASFBaseAttribute`

class mutagen.asf.ASFUnicodeAttribute(value)

  Unicode string attribute.

      ASFUnicodeAttribute(u'some text')

  Bases:

    `ASFBaseAttribute`